## wxpython4.0 4.2.1+dfsg

=== wscript ===
#!/usr/bin/python
#-----------------------------------------------------------------------------
#  WAF script for building and installing the wxPython extension modules.
#
# Author:      Robin Dunn
# Copyright:   (c) 2013-2020 by Total Control Software
# License:     wxWindows License
#-----------------------------------------------------------------------------

import sys
import os
import setuptools

try:
    from textwrap import indent
except ImportError:
    from buildtools.backports.textwrap3 import indent

from buildtools.config import Config, runcmd, msg, getMSVCInfo
cfg = Config(True)

#-----------------------------------------------------------------------------
# Options and configuration

APPNAME = 'wxPython'
VERSION = cfg.VERSION

isWindows = sys.platform.startswith('win')
isDarwin = sys.platform == "darwin"

top = '.'
out = 'build/waf'


def options(opt):
    if isWindows:
        opt.load('msvc')
    opt.load('compiler_c compiler_cxx')
    opt.load('python')

    opt.add_option('--debug', dest='debug', action='store_true', default=False,
                   help='Turn on debugger-related compile options.')
    opt.add_option('--python', dest='python', default='', action='store',
                   help='Full path to the Python executable to use.')
    opt.add_option('--wx_config', dest='wx_config', default='wx-config', action='store',
                   help='Full path to the wx-config script to be used for this build.')
    opt.add_option('--no_magic', dest='no_magic', action='store_true', default=False,
                   help='Don\'t use linker magic to enable wx libs to be bundled with '
                   'wxPython.  See build.py for more info.')
    opt.add_option('--mac_arch', dest='mac_arch', default='', action='store',
                   help='One or more comma separated architecture names to be used for '
                   'the Mac builds. Should be at least a subset of the architectures '
                   'used by wxWidgets and Python')
    opt.add_option('--gtk2', dest='gtk2', action='store_true', default=False,
                   help='On Linux build for gtk2 (default gtk3)')
    opt.add_option('--gtk3', dest='gtk3', action='store_true', default=True,
                   help='On Linux build for gtk3')
    opt.add_option('--no_msvc', dest='use_msvc', action='store_false', default=isWindows,
                   help='Set to use a MinGW toolchain')
    opt.add_option('--msvc_arch', dest='msvc_arch', default='x86', action='store',
                   help='The architecture to target for MSVC builds. Supported values '
                   'are: "x86" or "x64"')
    opt.add_option('--msvc_relwithdebug', dest='msvc_relwithdebug', action='store_true', default=False,
                   help='Turn on debug info for release builds for MSVC builds.')



def configure(conf):
    if conf.options.use_msvc:
        # Set up the MSVC compiler info for wxPython's build

        PYTHON = conf.options.python if conf.options.python else sys.executable
        info = getMSVCInfo(PYTHON, conf.options.msvc_arch, set_env=True)

        # WAF uses the VisualStudio version to select the compiler, rather than
        # the compiler version like we see elsewhere. Luckily we've got that
        # value in the MSVC info.
        msvc_version = f"msvc {info.vs_ver}"

        conf.env['MSVC_VERSIONS'] = [msvc_version]
        conf.env['MSVC_TARGETS'] = [conf.options.msvc_arch]
        conf.load('msvc')
    else:
        # Otherwise, use WAF's default setup for the C and C++ compiler
        conf.load('compiler_c compiler_cxx')
        if isWindows:
            conf.load('winres')

    # Set up Python
    if conf.options.python:
        conf.env.PYTHON = conf.options.python
    conf.load('python')
    conf.check_python_version(minver=(3,7,0))
    if isWindows:
        # Search for the Python headers without doing some stuff that could
        # incorrectly fail on Windows. See my_check_python_headers below.
        # TODO: Check if it can/should be used on other platforms too.
        conf.my_check_python_headers()
    else:
        conf.check_python_headers(features='pyext')

    # fetch and save the debug options
    conf.env.debug = conf.options.debug
    conf.env.msvc_relwithdebug = conf.options.msvc_relwithdebug

    conf.env.use_msvc = conf.options.use_msvc

    # Ensure that the headers in siplib and Phoenix's src dir can be found
    conf.env.INCLUDES_WXPY = ['sip/siplib', 'wx/include', 'src']

    if conf.options.use_msvc:
        # Windows/MSVC specific stuff

        cfg.finishSetup(debug=conf.env.debug)

        conf.env.INCLUDES_WX = cfg.includes
        conf.env.DEFINES_WX = cfg.wafDefines
        conf.env.CFLAGS = cfg.cflags
        conf.env.CXXFLAGS = cfg.cxxflags
        conf.env.CFLAGS_WX = list()
        conf.env.CXXFLAGS_WX = list()
        conf.env.LIBPATH_WX = cfg.libdirs
        conf.env.LIB_WX = cfg.libs
        conf.env.LIBFLAGS_WX = cfg.lflags

        _copyEnvGroup(conf.env, '_WX', '_WXADV')
        conf.env.LIB_WXADV += cfg.makeLibName('adv')

        _copyEnvGroup(conf.env, '_WX', '_WXSTC')
        conf.env.LIB_WXSTC += cfg.makeLibName('stc')

        _copyEnvGroup(conf.env, '_WX', '_WXHTML')
        conf.env.LIB_WXHTML += cfg.makeLibName('html')

        _copyEnvGroup(conf.env, '_WX', '_WXGL')
        conf.env.LIB_WXGL += cfg.makeLibName('gl')

        _copyEnvGroup(conf.env, '_WX', '_WXWEBVIEW')
        conf.env.LIB_WXWEBVIEW += cfg.makeLibName('webview')

        _copyEnvGroup(conf.env, '_WX', '_WXXML')
        conf.env.LIB_WXXML += cfg.makeLibName('xml', isMSWBase=True)

        _copyEnvGroup(conf.env, '_WX', '_WXXRC')
        conf.env.LIB_WXXRC += cfg.makeLibName('xrc')

        _copyEnvGroup(conf.env, '_WX', '_WXRICHTEXT')
        conf.env.LIB_WXRICHTEXT += cfg.makeLibName('richtext')
        conf.env.LIB_WXRICHTEXT += cfg.makeLibName('adv')

        _copyEnvGroup(conf.env, '_WX', '_WXMEDIA')
        conf.env.LIB_WXMEDIA += cfg.makeLibName('media')

        _copyEnvGroup(conf.env, '_WX', '_WXRIBBON')
        conf.env.LIB_WXRIBBON += cfg.makeLibName('ribbon')

        _copyEnvGroup(conf.env, '_WX', '_WXPROPGRID')
        conf.env.LIB_WXPROPGRID += cfg.makeLibName('propgrid')

        _copyEnvGroup(conf.env, '_WX', '_WXAUI')
        conf.env.LIB_WXAUI += cfg.makeLibName('aui')

        # ** Add code for new modules here (and below for non-MSW)


        # tweak the PYEXT compile and link flags if making a --debug build
        if conf.env.debug:
            for listname in ['CFLAGS_PYEXT', 'CXXFLAGS_PYEXT']:
                lst = conf.env[listname]
                for opt in '/Ox /MD /DNDEBUG'.split():
                    try:
                        lst.remove(opt)
                    except ValueError:
                        pass
                # NOTE: For --debug builds the /Z7 flag is used so the debug
                # info will be in each object file instead of a separate PDB
                # file. This will result in much faster builds since VC won't
                # have to serialize access to the .pdb file. OTOH, separate
                # PDB files are generated for the --msvc_relwithdebug option,
                # which is handled below in the makeETGRule() function.
                lst[1:1] = '/Od /MDd /Z7 /D_DEBUG'.split()

            conf.env['LINKFLAGS_PYEXT'].append('/DEBUG')
            conf.env['LIB_PYEXT'][0] += '_d'


    else: # not isWindows
        # TODO: Double-check that this works when using an installed wxWidgets
        wxConfigDir = cfg.findWxConfigDir(conf.options.wx_config)

        # Configuration stuff for non-Windows ports using wx-config
        # First finish configuring the Config object
        conf.env.wx_config = conf.options.wx_config
        cfg.finishSetup(conf.env.wx_config, conf.env.debug,
                        'mingw32' if isWindows and not conf.env.use_msvc else None)

        conf.env.CFLAGS = cfg.cflags[:]
        conf.env.CXXFLAGS = cfg.cxxflags[:]
        conf.env.CFLAGS_WX = list()
        conf.env.CXXFLAGS_WX = list()
        conf.env.CFLAGS_WXPY = list()
        conf.env.CXXFLAGS_WXPY = list()

        # Check wx-config exists and fetch some values from it
        rpath = ' --no-rpath' if not conf.options.no_magic else ''
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs core,net' + rpath,
                       uselib_store='WX', mandatory=True,
                       msg='Finding libs for WX')

        # Run it again with different libs options to get different
        # sets of flags stored to use with varous extension modules below.
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs adv,core,net' + rpath,
                       uselib_store='WXADV', mandatory=True,
                       msg='Finding libs for WXADV')

        libname = '' if cfg.MONOLITHIC else 'stc,' # workaround bug in wx-config
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args=('--cxxflags --libs %score,net' % libname) + rpath,
                       uselib_store='WXSTC', mandatory=True,
                       msg='Finding libs for WXSTC')

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs html,core,net' + rpath,
                       uselib_store='WXHTML', mandatory=True,
                       msg='Finding libs for WXHTML')

        if cfg.checkSetup(wxConfigDir, 'wxUSE_GLCANVAS'):
            gl_libs = '--libs gl,core,net'
        else:
            gl_libs = '--libs core,net'
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags ' + gl_libs + rpath,
                       uselib_store='WXGL', mandatory=True,
                       msg='Finding libs for WXGL')

        if cfg.checkSetup(wxConfigDir, 'wxUSE_WEBVIEW'):
            wv_libs = '--libs webview,core,net'
        else:
            wv_libs = '--libs core,net'
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags ' + wv_libs + rpath,
                       uselib_store='WXWEBVIEW', mandatory=True,
                       msg='Finding libs for WXWEBVIEW')

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs xml,core,net' + rpath,
                       uselib_store='WXXML', mandatory=True,
                       msg='Finding libs for WXXML')

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs xrc,xml,core,net' + rpath,
                       uselib_store='WXXRC', mandatory=True,
                       msg='Finding libs for WXXRC')

        libname = '' if cfg.MONOLITHIC else 'richtext,' # workaround bug in wx-config
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs %score,net' % libname + rpath,
                       uselib_store='WXRICHTEXT', mandatory=True,
                       msg='Finding libs for WXRICHTEXT')

        if cfg.checkSetup(wxConfigDir, 'wxUSE_MEDIACTRL'):
            mc_libs = '--libs media,core,net'
        else:
            mc_libs = '--libs core,net'
        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags ' + mc_libs + rpath,
                       uselib_store='WXMEDIA', mandatory=True,
                       msg='Finding libs for WXMEDIA')

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs ribbon,core,net' + rpath,
                       uselib_store='WXRIBBON', mandatory=True,
                       msg='Finding libs for WXRIBBON')

        conf.check_cfg(path=conf.options.wx_config, package='',
                       args='--cxxflags --libs propgrid,core' + rpath,

=== ext/wxWidgets/build/cmake/lib/base/CMakeLists.txt ===
#############################################################################
# Name:        build/cmake/lib/base/CMakeLists.txt
# Purpose:     CMake file for base library
# Author:      Tobias Taschner
# Created:     2016-09-20
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

wx_append_sources(BASE_FILES BASE_CMN)
wx_append_sources(BASE_FILES BASE_AND_GUI_CMN)

if(WIN32)
    wx_append_sources(BASE_FILES BASE_WIN32)
    wx_append_sources(BASE_FILES BASE_AND_GUI_WIN32)
elseif(APPLE)
    wx_append_sources(BASE_FILES BASE_OSX_SHARED)
    if(WXOSX_COCOA)
        wx_append_sources(BASE_FILES BASE_AND_GUI_OSX_COCOA)
    endif()
elseif(UNIX)
    wx_append_sources(BASE_FILES BASE_UNIX)
endif()

wx_add_library(wxbase IS_BASE ${BASE_FILES})

if(wxUSE_ZLIB)
    wx_lib_include_directories(wxbase ${ZLIB_INCLUDE_DIRS})
    wx_lib_link_libraries(wxbase PRIVATE ${ZLIB_LIBRARIES})
endif()
if(wxUSE_REGEX)
    wx_lib_include_directories(wxbase ${REGEX_INCLUDE_DIRS})
    wx_lib_link_libraries(wxbase PRIVATE ${REGEX_LIBRARIES})
endif()
if(wxUSE_LIBLZMA)
    wx_lib_include_directories(wxbase ${LIBLZMA_INCLUDE_DIRS})
    wx_lib_link_libraries(wxbase PRIVATE ${LIBLZMA_LIBRARIES})
endif()
if(UNIX AND wxUSE_SECRETSTORE)
    wx_lib_include_directories(wxbase ${LIBSECRET_INCLUDE_DIRS})
    wx_lib_link_libraries(wxbase PRIVATE ${LIBSECRET_LIBRARIES})
endif()
if(wxUSE_LIBICONV)
    wx_lib_include_directories(wxbase ${ICONV_INCLUDE_DIR})
    wx_lib_link_libraries(wxbase PRIVATE ${ICONV_LIBRARIES})
endif()
if(wxUSE_THREADS AND CMAKE_THREAD_LIBS_INIT)
    wx_lib_link_libraries(wxbase PRIVATE ${CMAKE_THREAD_LIBS_INIT})
endif()

if(APPLE)
    wx_lib_link_libraries(wxbase
        PUBLIC
        "-framework CoreFoundation"
    )
    if(WXOSX_COCOA)
        wx_lib_link_libraries(wxbase
            PRIVATE
            "-framework Security"
            PUBLIC
            "-framework Carbon"
            "-framework Cocoa"
            "-framework IOKit"
            "-framework QuartzCore"
        )
    endif()
elseif(UNIX)
    wx_lib_link_libraries(wxbase PRIVATE ${CMAKE_DL_LIBS})
endif()

=== ext/wxWidgets/build/cmake/lib/html/CMakeLists.txt ===
#############################################################################
# Name:        build/cmake/lib/html/CMakeLists.txt
# Purpose:     CMake file for html library
# Author:      Tobias Taschner
# Created:     2016-10-03
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

wx_append_sources(HTML_FILES HTML_CMN)

if(WIN32 OR wxUSE_LIBMSPACK)
    wx_append_sources(HTML_FILES HTML_MSW)
endif()

wx_add_library(wxhtml ${HTML_FILES})

if(wxUSE_LIBMSPACK)
    wx_lib_include_directories(wxhtml ${MSPACK_INCLUDE_DIRS})
    wx_lib_link_libraries(wxhtml PRIVATE ${MSPACK_LIBRARIES})
endif()

=== ext/wxWidgets/build/cmake/lib/qa/CMakeLists.txt ===
#############################################################################
# Name:        build/cmake/lib/qa/CMakeLists.txt
# Purpose:     CMake file for qa library
# Author:      Tobias Taschner
# Created:     2016-10-03
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

wx_append_sources(QA_FILES QA)

wx_add_library(wxqa ${QA_FILES})
wx_lib_link_libraries(wxqa PUBLIC wxxml)

=== debian/changelog ===
wxpython4.0 (4.2.1+dfsg-4) unstable; urgency=medium

  * Fix FTBFS with sip 6.8.5+ (Closes: #1074751)
  * Update Standards-Version to 4.7.0 (no changes needed)

 -- Scott Talbert <swt@techie.net>  Sat, 06 Jul 2024 10:43:00 -0400

=== debian/control ===
Source: wxpython4.0
Section: python
Priority: optional
Maintainer: wxWidgets Maintainers <team+wx@tracker.debian.org>
Uploaders: Scott Talbert <swt@techie.net>
Build-Depends:
    debhelper-compat (= 13),
    dh-python,
    doxygen,
    libgtk-3-dev,
    libwxgtk3.2-dev,
    libwxgtk-media3.2-dev,
    libwxgtk-webview3.2-dev,
    python3-all,
    python3-all-dev,
    python3-numpy,
    python3-pil,
    python3-pytest,
    python3-pytest-forked,
    python3-pytest-timeout,
    python3-pytest-xdist,
    python3-setuptools,
    python3-sipbuild (>= 6.8.5),
    python3-six,
    sip-tools (>= 6.8.5),
    xauth,
    xvfb,
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/freewx-team/wxpython4.0.git
Vcs-Browser: https://salsa.debian.org/freewx-team/wxpython4.0
Homepage: https://www.wxpython.org/
Rules-Requires-Root: no

Package: python3-wxgtk4.0
Architecture: any
Depends: python3-pil, python3-six, ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Suggests: wx3.2-doc
Provides: ${python3:Provides}
Description: Python 3 interface to the wxWidgets Cross-platform C++ GUI toolkit
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides a Python 3 interface to the wxGTK library and the
 wxPython runtime support libraries.  This is the Phoenix reimplementation of
 wxPython.

Package: python3-wxgtk-media4.0
Architecture: any
Depends: python3-wxgtk4.0 (= ${binary:Version}), ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python3:Provides}
Description: Python 3 interface to the wxWidgets Cross-platform C++ GUI toolkit (wx.media)
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides a Python 3 interface to wxMediaCtrl.  This is the Phoenix
 reimplementation of wxPython.

Package: python3-wxgtk-webview4.0
Architecture: any
Depends: python3-wxgtk4.0 (= ${binary:Version}), ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python3:Provides}
Description: Python 3 interface to the wxWidgets Cross-platform C++ GUI toolkit (wx.html2)
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides a Python 3 interface to wxWebView.  This is the Phoenix
 reimplementation of wxPython.

Package: wxpython-tools
Architecture: all
Depends: python3-wxgtk4.0, ${python3:Depends}, ${misc:Depends}
Provides: python-wxtools
Replaces: python-wxtools
Conflicts: python-wxtools
Description: Tools from the wxPython distribution
 wxWidgets (formerly known as wxWindows) is a class library for C++ providing
 GUI components and other facilities on several popular platforms (and some
 unpopular ones as well).
 .
 This package provides support utilities and common files for wxPython.

## wxpython4.0 4.2.2%2Bdfsg

=== debian/changelog ===
wxpython4.0 (4.2.2+dfsg-1) unstable; urgency=medium

  * Update to new upstream release 4.2.2
  * Add cython3 to BD to fix FTBFS w/ Py 3.13 (Closes: #1081613)

 -- Scott Talbert <swt@techie.net>  Tue, 17 Sep 2024 00:15:19 -0400

## wxpython4.0 4.2.2+dfsg

=== wscript ===
--- 
+++ 
@@ -16,7 +16,7 @@
 except ImportError:
     from buildtools.backports.textwrap3 import indent
 
-from buildtools.config import Config, runcmd, msg, getMSVCInfo
+from buildtools.config import Config, runcmd, msg, getMSVCInfo, generateVersionFiles
 cfg = Config(True)
 
 #-----------------------------------------------------------------------------
@@ -91,13 +91,7 @@
         conf.env.PYTHON = conf.options.python
     conf.load('python')
     conf.check_python_version(minver=(3,7,0))
-    if isWindows:
-        # Search for the Python headers without doing some stuff that could
-        # incorrectly fail on Windows. See my_check_python_headers below.
-        # TODO: Check if it can/should be used on other platforms too.
-        conf.my_check_python_headers()
-    else:
-        conf.check_python_headers(features='pyext')
+    conf.check_python_headers(features='pyext')
 
     # fetch and save the debug options
     conf.env.debug = conf.options.debug
@@ -276,3 +270,9 @@
 
         conf.check_cfg(path=conf.options.wx_config, package='',
                        args='--cxxflags --libs propgrid,core' + rpath,
+                       uselib_store='WXPROPGRID', mandatory=True,
+                       msg='Finding libs for WXPROPGRID')
+
+        conf.check_cfg(path=conf.options.wx_config, package='',
+                       args='--cxxflags --libs aui,core' + rpath,
+                       uselib_store='WXAUI', mandatory=True,

=== ext/wxWidgets/CMakeLists.txt ===
#############################################################################
# Name:        CMakeLists.txt
# Purpose:     Primary CMake for wxWidgets
# Author:      Tobias Taschner
# Created:     2016-09-20
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

cmake_minimum_required(VERSION 3.0)

if(NOT CMAKE_CONFIGURATION_TYPES)
    get_property(HAVE_MULTI_CONFIG_GENERATOR GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
    # Set default configuration types for multi-config generators
    if(HAVE_MULTI_CONFIG_GENERATOR)
        set(CMAKE_CONFIGURATION_TYPES "Debug;Release")
    endif()
endif()

file(TO_CMAKE_PATH "${CMAKE_INSTALL_PREFIX}" CMAKE_INSTALL_PREFIX)

# https://blog.kitware.com/cmake-and-the-default-build-type/
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    set(default_build_type "Debug")
    message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
    set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE STRING "Choose the type of build." FORCE)
    # Set the possible values of build type for cmake-gui
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release")
endif()

# This block, particularly the versions used, should be kept in sync with
# samples/minimal/CMakeLists.txt.
if(APPLE AND NOT CMAKE_OSX_DEPLOYMENT_TARGET)
    # If no deployment target has been set default to the minimum supported
    # OS version (this has to be set before the first project() call)
    if(CMAKE_SYSTEM_NAME STREQUAL "iOS")
        set(CMAKE_OSX_DEPLOYMENT_TARGET 12.0 CACHE STRING "iOS Deployment Target")
    else()
        set(CMAKE_OSX_DEPLOYMENT_TARGET 10.10 CACHE STRING "macOS Deployment Target")
    endif()
endif()

include(build/cmake/policies.cmake NO_POLICY_SCOPE)

# Initialize variables for quick access to wx root dir in sub dirs
set(wxSOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(wxBINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})
set(wxOUTPUT_DIR ${wxBINARY_DIR}/lib)

# parse the version number from wx/version.h and include in wxMAJOR_VERSION and wxMINOR_VERSION
file(READ "${wxSOURCE_DIR}/include/wx/version.h" WX_VERSION_H_CONTENTS)
string(REGEX MATCH "wxMAJOR_VERSION[ \t]+([0-9]+)"
    wxMAJOR_VERSION ${WX_VERSION_H_CONTENTS})
string (REGEX MATCH "([0-9]+)"
    wxMAJOR_VERSION ${wxMAJOR_VERSION})
string(REGEX MATCH "wxMINOR_VERSION[ \t]+([0-9]+)"
    wxMINOR_VERSION ${WX_VERSION_H_CONTENTS})
string (REGEX MATCH "([0-9]+)"
    wxMINOR_VERSION ${wxMINOR_VERSION})
string(REGEX MATCH "wxRELEASE_NUMBER[ \t]+([0-9]+)"
    wxRELEASE_NUMBER ${WX_VERSION_H_CONTENTS})
string (REGEX MATCH "([0-9]+)"
    wxRELEASE_NUMBER ${wxRELEASE_NUMBER})

# Determine if current version is a "Development" release
math(EXPR rel_dev "${wxMINOR_VERSION} % 2")
if(rel_dev)
    set(wxVERSION_IS_DEV TRUE)
else()
    set(wxVERSION_IS_DEV FALSE)
endif()

# parse the .so version from build/bakefiles/version.bkl
file(READ "${wxSOURCE_DIR}/build/bakefiles/version.bkl" WX_VERSION_BKL_CONTENTS)
string(REGEX MATCH "WX_CURRENT.>([0-9]+)"
    WX_CURRENT ${WX_VERSION_BKL_CONTENTS})
string(REGEX MATCH "([0-9]+)"
    WX_CURRENT ${WX_CURRENT})
string(REGEX MATCH "WX_REVISION.>([0-9]+)"
    WX_REVISION ${WX_VERSION_BKL_CONTENTS})
string(REGEX MATCH "([0-9]+)"
    WX_REVISION ${WX_REVISION})
string(REGEX MATCH "WX_AGE.>([0-9]+)"
    WX_AGE ${WX_VERSION_BKL_CONTENTS})
string(REGEX MATCH "([0-9]+)"
    WX_AGE ${WX_AGE})
math(EXPR wxSOVERSION_MAJOR "${WX_CURRENT} - ${WX_AGE}")
set(wxSOVERSION ${wxSOVERSION_MAJOR}.${WX_AGE}.${WX_REVISION})

set(wxVERSION ${wxMAJOR_VERSION}.${wxMINOR_VERSION}.${wxRELEASE_NUMBER})
set(wxCOPYRIGHT "2002-2024 wxWidgets")

set(wxLANGUAGES C CXX)
if(APPLE AND NOT CMAKE_VERSION VERSION_LESS "3.16")
    list(APPEND wxLANGUAGES OBJCXX)
endif()

project(wxWidgets VERSION ${wxVERSION} LANGUAGES ${wxLANGUAGES})

include(build/cmake/main.cmake)

# Set the default startup project for Visual Studio
if(wxBUILD_SAMPLES AND wxUSE_GUI)
    set_directory_properties(PROPERTIES VS_STARTUP_PROJECT minimal)
endif()

=== ext/wxWidgets/build/cmake/lib/CMakeLists.txt ===
#############################################################################
# Name:        build/cmake/lib/CMakeLists.txt
# Purpose:     Main lib CMake file
# Author:      Tobias Taschner
# Created:     2016-10-14
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

if(wxBUILD_MONOLITHIC)
    # Initialize variables for monolithic build
    set(wxMONO_SRC_FILES)
    set(wxMONO_LIBS_PRIVATE)
    set(wxMONO_LIBS_PUBLIC)
    set(wxMONO_INCLUDE_DIRS)
    set(wxMONO_DEFINITIONS)
    set(wxMONO_NONCOMPILED_CPP_FILES)
    set(wxMONO_DEPENDENCIES)
endif()

# Define third party libraries
set(LIBS_THIRDPARTY regex zlib expat)
if(wxUSE_GUI)
    list(APPEND LIBS_THIRDPARTY jpeg png tiff nanosvg)
endif()
foreach(LIB IN LISTS LIBS_THIRDPARTY)
    include(${LIB}.cmake)
endforeach()

# add_opt_lib()
# Add library which may have been disabled by wxUSE_...
macro(add_opt_lib name var_name)
    if(${var_name})
        list(APPEND LIBS ${name})
    endif()
endmacro()

# Define base libraries
set(LIBS base)
add_opt_lib(net wxUSE_SOCKETS)

# Define UI libraries
if(wxUSE_GUI)
    list(APPEND LIBS core adv)
    foreach(lib
        aui
        html
        propgrid
        ribbon
        richtext
        webview
        stc
        xrc
        )
        string(TOUPPER ${lib} _name_upper)
        add_opt_lib(${lib} wxUSE_${_name_upper})
    endforeach()
    add_opt_lib(media wxUSE_MEDIACTRL)
    add_opt_lib(gl wxUSE_OPENGL)
    add_opt_lib(qa wxUSE_DEBUGREPORT)
endif() # wxUSE_GUI

# Include XML library last
# In the monolithic build, where all target properties (include dirs) from different targets are concatenated,
# wxml might include system expat, which might use Mono, which has it's own copy of png.
# Thus to ensure wx's core library includes the right png class, core must be processed first before xml
add_opt_lib(xml wxUSE_XML)

# Include cmake file for every library
foreach(LIB ${LIBS})
    add_subdirectory(${LIB})
endforeach()

if(wxBUILD_MONOLITHIC)
    # Create monolithic library target
    wx_add_library(wxmono IS_MONO ${wxMONO_SRC_FILES})
    foreach(vis PRIVATE PUBLIC)
        if(wxMONO_LIBS_${vis})
            # Remove libs included in mono from list
            foreach(lib IN LISTS LIBS)
                list(REMOVE_ITEM wxMONO_LIBS_${vis} wx${lib})
            endforeach()

            target_link_libraries(wxmono ${vis} ${wxMONO_LIBS_${vis}})
        endif()
    endforeach()
    if(wxMONO_INCLUDE_DIRS)
        target_include_directories(wxmono BEFORE PRIVATE ${wxMONO_INCLUDE_DIRS})
    endif()
    if(wxMONO_DEFINITIONS)
        target_compile_definitions(wxmono PRIVATE ${wxMONO_DEFINITIONS})
    endif()
    foreach(file ${wxMONO_NONCOMPILED_CPP_FILES})
        set_source_files_properties(${file} PROPERTIES HEADER_FILE_ONLY TRUE)
    endforeach()
    foreach(dep ${wxMONO_DEPENDENCIES})
        add_dependencies(wxmono ${dep})
    endforeach()
    if(wxUSE_WEBVIEW)
        wx_webview_copy_webview2_loader(wxmono)
    endif()
endif()

# Propagate variable(s) to parent scope
set(wxLIB_TARGETS ${wxLIB_TARGETS} PARENT_SCOPE)

=== ext/wxWidgets/build/cmake/lib/core/CMakeLists.txt ===
#############################################################################
# Name:        build/cmake/lib/core/CMakeLists.txt
# Purpose:     CMake file for core library
# Author:      Tobias Taschner
# Created:     2016-10-01
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

wx_append_sources(CORE_SRC GUI_CMN)
wx_append_sources(CORE_SRC BASE_AND_GUI_CMN)
if(WIN32)
    wx_append_sources(CORE_SRC BASE_AND_GUI_WIN32)
elseif(UNIX)
    wx_append_sources(CORE_SRC UNIX)
    if(wxUSE_LIBSDL)
        wx_append_sources(CORE_SRC UNIX_SOUND_SDL)
    endif()
endif()

if(WXMSW)
    wx_append_sources(CORE_SRC MSW_LOWLEVEL)
    wx_append_sources(CORE_SRC MSW_DESKTOP_LOWLEVEL)
    wx_append_sources(CORE_SRC MSW)
    wx_append_sources(CORE_SRC MSW_DESKTOP)
    if(NOT wxUSE_OLE)
        wx_list_add_prefix(CORE_SRC "${wxSOURCE_DIR}/" "src/generic/dirdlgg.cpp")
    endif()
elseif(WXGTK)
    if(WXGTK2)
        wx_append_sources(CORE_SRC GTK2_LOWLEVEL)
        wx_append_sources(CORE_SRC GTK2)
    else()
        wx_append_sources(CORE_SRC GTK_LOWLEVEL)
        wx_append_sources(CORE_SRC GTK)
    endif()

    if(UNIX)
        wx_append_sources(CORE_SRC XWIN_LOWLEVEL)
    elseif(WIN32)
        wx_append_sources(CORE_SRC GTK_WIN32)
    endif()
elseif(WXOSX_COCOA)
    wx_append_sources(CORE_SRC BASE_AND_GUI_OSX_COCOA)
    wx_append_sources(CORE_SRC OSX_LOWLEVEL)
    wx_append_sources(CORE_SRC OSX_SHARED)
    wx_append_sources(CORE_SRC OSX_COCOA)
elseif(WXOSX_IPHONE)
    wx_append_sources(CORE_SRC OSX_LOWLEVEL)
    wx_append_sources(CORE_SRC OSX_IPHONE)
elseif(WXQT)
    wx_append_sources(CORE_SRC QT)
    if(WIN32)
        wx_append_sources(CORE_SRC QT_WIN32)
    endif()
endif()

wx_add_library(wxcore ${CORE_SRC})
foreach(lib JPEG PNG TIFF NANOSVG)
    if(${lib}_LIBRARIES)
        wx_lib_link_libraries(wxcore PRIVATE ${${lib}_LIBRARIES})
    endif()
    if(${lib}_INCLUDE_DIRS)
        wx_lib_include_directories(wxcore ${${lib}_INCLUDE_DIRS})
    elseif(${lib}_INCLUDE_DIR)
        wx_lib_include_directories(wxcore ${${lib}_INCLUDE_DIR})
    endif()
endforeach()
if(wxUSE_NANOSVG STREQUAL "sys" AND wxUSE_NANOSVG_EXTERNAL_ENABLE_IMPL)
    wx_lib_compile_definitions(wxcore wxUSE_NANOSVG_EXTERNAL_ENABLE_IMPL)
endif()

if(WIN32)
    wx_lib_link_libraries(wxcore PRIVATE winmm)
endif()
if(WXOSX_COCOA)
    wx_lib_link_libraries(wxcore PUBLIC "-framework AudioToolbox")
    if(wxUSE_WEBVIEW)
        wx_lib_link_libraries(wxcore PUBLIC "-framework WebKit")
    endif()
endif()
if(WXOSX_IPHONE)
    wx_lib_link_libraries(wxcore
        PUBLIC
        "-framework AudioToolbox"
        "-framework CoreGraphics"
        "-framework CoreText"
        "-framework UIKit"
        )
endif()
if(WXGTK AND wxUSE_PRIVATE_FONTS)
    wx_lib_include_directories(wxcore ${FONTCONFIG_INCLUDE_DIRS} ${PANGOFT2_INCLUDE_DIRS})
    wx_lib_link_libraries(wxcore PUBLIC ${FONTCONFIG_LIBRARIES} ${PANGOFT2_LIBRARIES})
endif()
if(wxUSE_LIBSDL)
    if(SDL2_FOUND)
        wx_lib_include_directories(wxcore ${SDL2_INCLUDE_DIR})
        wx_lib_link_libraries(wxcore PUBLIC ${SDL2_LIBRARY})
    elseif(SDL_FOUND)
        wx_lib_include_directories(wxcore ${SDL_INCLUDE_DIR})
        wx_lib_link_libraries(wxcore PUBLIC ${SDL_LIBRARY})
    endif()
endif()
if(wxUSE_LIBNOTIFY)
    wx_lib_include_directories(wxcore ${LIBNOTIFY_INCLUDE_DIRS})
    wx_lib_link_libraries(wxcore PUBLIC ${LIBNOTIFY_LIBRARIES})
endif()
if(wxUSE_CAIRO AND NOT WXGTK)
    wx_lib_include_directories(wxcore ${CAIRO_INCLUDE_DIRS})
    # no libs, cairo is loaded dynamically
endif()

=== ext/wxWidgets/build/cmake/lib/xrc/CMakeLists.txt ===
#############################################################################
# Name:        build/cmake/lib/xrc/CMakeLists.txt
# Purpose:     CMake file for xrc library
# Author:      Tobias Taschner
# Created:     2016-10-03
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

wx_append_sources(XRC_FILES XRC)

wx_add_library(wxxrc ${XRC_FILES})
wx_lib_link_libraries(wxxrc PRIVATE wxhtml wxxml)

=== ext/wxWidgets/build/cmake/tests/base/CMakeLists.txt ===
#############################################################################
# Name:        build/cmake/tests/base/CMakeLists.txt
# Purpose:     CMake file for base test
# Author:      Tobias Taschner
# Created:     2016-10-31
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

set(TEST_SRC
    test.cpp
    any/anytest.cpp
    archive/archivetest.cpp
    archive/ziptest.cpp
    archive/tartest.cpp
    arrays/arrays.cpp
    base64/base64.cpp
    cmdline/cmdlinetest.cpp
    config/fileconf.cpp
    config/regconf.cpp
    datetime/datetimetest.cpp
    events/evthandler.cpp
    events/evtlooptest.cpp
    events/evtsource.cpp
    events/stopwatch.cpp
    events/timertest.cpp
    exec/exec.cpp
    file/dir.cpp
    file/filefn.cpp
    file/filetest.cpp
    filekind/filekind.cpp
    filename/filenametest.cpp
    filesys/filesystest.cpp
    fontmap/fontmaptest.cpp
    formatconverter/formatconvertertest.cpp
    fswatcher/fswatchertest.cpp
    hashes/hashes.cpp
    interactive/output.cpp
    interactive/input.cpp
    intl/intltest.cpp
    lists/lists.cpp
    log/logtest.cpp
    longlong/longlongtest.cpp
    mbconv/convautotest.cpp
    mbconv/mbconvtest.cpp
    misc/dynamiclib.cpp
    misc/environ.cpp
    misc/metatest.cpp
    misc/misctests.cpp
    misc/module.cpp
    misc/pathlist.cpp
    misc/typeinfotest.cpp
    net/ipc.cpp
    net/socket.cpp
    net/webrequest.cpp
    regex/regextest.cpp
    regex/wxregextest.cpp
    scopeguard/scopeguardtest.cpp
    strings/iostream.cpp
    strings/numformatter.cpp
    strings/strings.cpp
    strings/stdstrings.cpp
    strings/tokenizer.cpp
    strings/unichar.cpp
    strings/unicode.cpp
    strings/vararg.cpp
    strings/crt.cpp
    strings/vsnprintf.cpp
    strings/hexconv.cpp
    streams/datastreamtest.cpp
    streams/ffilestream.cpp
    streams/fileback.cpp
    streams/filestream.cpp
    streams/iostreams.cpp
    streams/largefile.cpp
    streams/lzmastream.cpp
    streams/memstream.cpp
    streams/socketstream.cpp
    streams/sstream.cpp
    streams/stdstream.cpp
    streams/tempfile.cpp
    streams/textstreamtest.cpp
    streams/zlibstream.cpp
    textfile/textfiletest.cpp
    thread/atomic.cpp
    thread/misc.cpp
    thread/queue.cpp
    thread/tls.cpp
    uris/ftp.cpp
    uris/uris.cpp
    uris/url.cpp
    vectors/vectors.cpp
    weakref/evtconnection.cpp
    weakref/weakref.cpp
    xlocale/xlocale.cpp

    testprec.h
    testableframe.h
    testdate.h
    testfile.h
    archive/archivetest.h
    streams/bstream.h
    )

if(wxUSE_XML)
    list(APPEND TEST_SRC xml/xmltest.cpp)
endif()

set(TEST_DATA
    intl/en_GB/internat.mo
    intl/en_GB/internat.po
    intl/fr/internat.mo
    intl/fr/internat.po
    intl/ja/internat.mo
    intl/ja/internat.po
    horse.bmp
    horse.png
    horse.xpm
    testdata.conf
    )

wx_add_test(test_base CONSOLE ${TEST_SRC}
    DATA ${TEST_DATA}
    )
if(wxUSE_SOCKETS)
    wx_exe_link_libraries(test_base wxnet)
endif()
if(wxUSE_XML)
    wx_exe_link_libraries(test_base wxxml)
endif()

=== ext/wxWidgets/build/cmake/tests/drawing/CMakeLists.txt ===
#############################################################################
# Name:        build/cmake/tests/drawing/CMakeLists.txt
# Purpose:     CMake file for drawing test
# Author:      Tobias Taschner
# Created:     2016-10-31
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

# This test program is targeted to "headless GUI" tests, tests which are
# typically tied to the "core" component but that should run nicely in a
# console only program. This program should be executable from a console
# only Unix session (such as telnet or ssh) although it uses graphics
# contexts, so if you modify this project, please check that it can still
# be ran in such configuration and doesn't require an X server connection.
set(TEST_DRAWING_SRC
    test.cpp
    testableframe.cpp
    drawing/drawing.cpp
    drawing/plugindriver.cpp
    drawing/basictest.cpp
    drawing/fonttest.cpp

    testprec.h
    testableframe.h
    testimage.h
    drawing/drawing.h
    drawing/gcfactory.h
    drawing/plugin.h
    drawing/pluginsample.cpp
    drawing/testimagefile.h
    )

set(TEST_DRAWING_DATA
    drawing/references/image_test_image_cairo-1.8_2_ref.png
    drawing/references/image_test_image_cg-10.5_2_ref.png
    drawing/references/image_test_image_gdiplus-6.1_2_ref.png
    )

wx_add_test(test_drawing CONSOLE_GUI ${TEST_DRAWING_SRC}
    DATA ${TEST_DRAWING_DATA}
    )
if(wxUSE_SOCKETS)
    wx_exe_link_libraries(test_drawing wxnet)
endif()

# This is a sample plugin, it simply uses a wxImage based
# wxGraphicsContext. It should render the same as the built-in test. Use
# the WX_TEST_SUITE_GC_DRAWING_PLUGINS variable to specify the location of
# the produced DLL/so to get it loaded and tested. To make your own plugin,
# you can copy this sample and link toward your own implementation of
# wxGraphicsContext interface, building the appropriate DrawingTestGCFactory
# TODO: test_drawingplugin

=== debian/changelog ===
wxpython4.0 (4.2.2+dfsg-3build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 20:16:52 +0000

wxpython4.0 (4.2.2+dfsg-3) unstable; urgency=medium

  * Fix FTBFS with sip 6.10.0 (Closes: #1095400)

 -- Scott Talbert <swt@techie.net>  Tue, 11 Feb 2025 23:49:18 -0500

wxpython4.0 (4.2.2+dfsg-2) unstable; urgency=medium

  * Fix iterator issue with Python 3.13.1 (Closes: #1094380)

 -- Scott Talbert <swt@techie.net>  Mon, 27 Jan 2025 19:53:17 -0500

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,12 @@
 Maintainer: wxWidgets Maintainers <team+wx@tracker.debian.org>
 Uploaders: Scott Talbert <swt@techie.net>
 Build-Depends:
+    cython3,
     debhelper-compat (= 13),
     dh-python,
     doxygen,
     libgtk-3-dev,
-    libwxgtk3.2-dev,
+    libwxgtk3.2-dev (>= 3.2.6),
     libwxgtk-media3.2-dev,
     libwxgtk-webview3.2-dev,
     python3-all,

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/default.mk

export DOXYGEN=/usr/bin/doxygen
export PYBUILD_SYSTEM=custom
export PYBUILD_BUILD_ARGS_python3=python{version} -u build.py dox touch etg --nodoc sip build_py --use_syswx --gtk3 --extra_waf "-v"
export PYBUILD_CLEAN_ARGS=python{version} build.py clean
export PYBUILD_BEFORE_INSTALL=mkdir -p {destdir}{install_dir}
export PYBUILD_INSTALL_ARGS_python3=python{version} build.py install_py --destdir={destdir} --extra_setup="--install-layout=deb"
SKIP_TESTS='not (test_frameRestore or test_newIdRef03)'
export PYBUILD_TEST_ARGS=xvfb-run -a python{version} -m pytest -v --forked --timeout=60 -k $(SKIP_TESTS) unittests || true
export PYBUILD_DISABLE=configure

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_install:
	dh_install
	# These are packaged in the -media subpackage:
	rm -f debian/python3-wxgtk4.0/usr/lib/python*/dist-packages/wx/_media.*so \
	      debian/python3-wxgtk4.0/usr/lib/python*/dist-packages/wx/media.py*
	# These are packaged in the -webview subpackage:
	rm -f debian/python3-wxgtk4.0/usr/lib/python*/dist-packages/wx/_html2.*so \
	      debian/python3-wxgtk4.0/usr/lib/python*/dist-packages/wx/html2.py*

override_dh_python3:
	dh_python3 --shebang=/usr/bin/python3

## wxpython4.0 4.2.3%2Bdfsg

=== debian/changelog ===
wxpython4.0 (4.2.3+dfsg-2build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 19 Oct 2025 12:19:25 +0000

wxpython4.0 (4.2.3+dfsg-2) unstable; urgency=medium

  * Remove runtime dependency on six (Closes: #1102534)

 -- Scott Talbert <swt@techie.net>  Fri, 11 Apr 2025 09:47:02 -0400

wxpython4.0 (4.2.3+dfsg-1) unstable; urgency=medium

  * Update to new upstream release 4.2.3 (Closes: #1102534)
  * Update Standards-Version to 4.7.2 (no changes needed)

 -- Scott Talbert <swt@techie.net>  Thu, 10 Apr 2025 20:07:08 -0400
